#!/bin/bash
#
# ssh-api:ssh-api.sh
#
if [ "$( type -t _ssh_api_do_ssh )" != 'function' ] ; then
  # shellcheck disable=SC1091
  source "$( dirname "${BASH_SOURCE[0]}" )/ssh-common-api.sh" || exit $?
fi

function ssh_api_do_ssh {
  local -r _ssh_user_="$1"
  local -r _ssh_host_="$2"
  local -r _ssh_cmd_="$3"

  _ssh_api_do_ssh "${_ssh_user_}" "${_ssh_host_}" "${_ssh_cmd_}" || return $?
}

function ssh_api_update_known_hosts {
  local -r host="$1"

  # Fix bad known_hosts files
  sed -i '/^null$/d' ~/.ssh/known_hosts || return $?

  # local -a ssh_keyscan_params=(-H) # All keys
  local -a ssh_keyscan_params=(-t ecdsa) # Key ECDSA

  while ssh-keygen -f ~/.ssh/known_hosts -H -F "${host}" >/dev/null ; do
    ssh-keygen -f ~/.ssh/known_hosts -R "${host}"
  done
  result="$( ssh-keyscan "${ssh_keyscan_params[@]}" "${host}" )" || return $?
  echo "${result}" >> ~/.ssh/known_hosts
}
